<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "directory_user".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DirectoryUser".
 *
 * Columns in table "directory_user" available as properties of the model,
 * followed by relations of table "directory_user" available as properties of the model.
 *
 * @property integer $id
 * @property string $email
 * @property string $password
 * @property integer $role
 * @property string $first_name
 * @property string $last_name
 * @property string $date_added
 * @property string $date_updated
 *
 * @property DirectoryRole $role0
 */
abstract class BaseDirectoryUser extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'directory_user';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DirectoryUser|DirectoryUsers', $n);
    }

    public static function representingColumn()
    {
        return 'email';
    }

    public function rules()
    {
        return array(
            array('role, date_added', 'required'),
            array('role', 'numerical', 'integerOnly'=>true),
            array('email', 'length', 'max'=>254),
            array('password', 'length', 'max'=>32),
            array('first_name', 'length', 'max'=>50),
            array('last_name', 'length', 'max'=>84),
            array('date_updated', 'safe'),
            array('email, password, first_name, last_name, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, email, password, role, first_name, last_name, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'role0' => array(self::BELONGS_TO, 'DirectoryRole', 'role'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'email' => Yii::t('app', 'Email'),
            'password' => Yii::t('app', 'Password'),
            'role' => null,
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'role0' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('password', $this->password, true);
        $criteria->compare('role', $this->role);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
